﻿Imports C1.Win.C1FlexGrid

Public Class Form1

    Public rowsMoved As Integer
    Public mouseUp As Boolean
    Dim firstRowIndex As Integer
    Dim frm2 As New Form2

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        frm2.Show()

        C1FlexGrid1.DragMode = DragModeEnum.Manual

        C1FlexGrid1.Rows.Count = 7
        C1FlexGrid1.Cols.Count = 4
        For r = 1 To C1FlexGrid1.Rows.Count - 1
            For c = 1 To C1FlexGrid1.Cols.Count - 1
                C1FlexGrid1(r, c) = "First - " + r.ToString() + ", " + c.ToString()
            Next
        Next
    End Sub

    Private Sub C1FlexGrid1_BeforeMouseDown(sender As Object, e As BeforeMouseDownEventArgs) Handles C1FlexGrid1.BeforeMouseDown
        If MouseUp = True Then
            Dim flex As C1FlexGrid = CType(sender, C1FlexGrid)
            Dim hti As HitTestInfo = flex.HitTest(e.X, e.Y)
            flex.Select(firstRowIndex, 0, firstRowIndex + rowsMoved - 1, flex.Cols.Count - 1, False)

            'do drag drop
            Dim dd As DragDropEffects = flex.DoDragDrop(flex.Clip, DragDropEffects.Move)

            'if it worked, delete rows from source (it's a move) 
            If dd = DragDropEffects.Move Then
                flex.Rows.RemoveRange(firstRowIndex, rowsMoved)
            End If
            mouseUp = False
        End If
        Console.WriteLine("BeforeMouseDown")
    End Sub

    Private Sub C1FlexGrid1_MouseUp(sender As Object, e As MouseEventArgs) Handles C1FlexGrid1.MouseUp
        Dim flex As C1FlexGrid = CType(sender, C1FlexGrid)
        Dim hti As HitTestInfo = flex.HitTest(e.X, e.Y)

        If hti.Type = HitTestTypeEnum.RowHeader Then
            mouseUp = True
            'Store number of selected rows
            frm2.rowsMoved = flex.Selection.r2 - flex.Selection.r1 + 1
            rowsMoved = frm2.rowsMoved
            firstRowIndex = flex.Selection.r1
        End If
        Console.WriteLine("MouseUp")
    End Sub
End Class