﻿Imports C1.Win.C1FlexGrid

Public Class Form2

    Public rowsMoved As Integer
    Public mouseUp As Boolean

    Private Sub Form2_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        C1FlexGrid2.DropMode = DropModeEnum.Manual

        C1FlexGrid2.Rows.Count = 7
        C1FlexGrid2.Cols.Count = 4
        For r = 1 To C1FlexGrid2.Rows.Count - 1
            For c = 1 To C1FlexGrid2.Cols.Count - 1
                C1FlexGrid2(r, c) = "Second - " + r.ToString() + ", " + c.ToString()
            Next
        Next
    End Sub

    Private Sub C1FlexGrid2_DragOver(sender As Object, e As DragEventArgs) Handles C1FlexGrid2.DragOver
        e.Effect = DragDropEffects.Move
    End Sub

    Private Sub C1FlexGrid2_DragDrop(sender As Object, e As DragEventArgs) Handles C1FlexGrid2.DragDrop
        'find the drop position
        Dim flex As C1FlexGrid = CType(sender, C1FlexGrid)
        Dim pt As Point = flex.PointToClient(New Point(e.X, e.Y))
        Dim hti As HitTestInfo = flex.HitTest(pt.X, pt.Y)
        Dim index As Integer = hti.Row

        If index < 0 Then index = flex.Rows.Count 'append
        If index < 1 Then index = 1 'after fixed row

        'insert new rows at the drop position
        For i = 1 To rowsMoved
            flex.Rows.Insert(index + i - 1)
        Next

        'copy data from source rows
        flex.Select(index, 0, index + rowsMoved - 1, flex.Cols.Count - 1, False)
        flex.Clip = CType(e.Data.GetData(GetType(String)), String)
    End Sub
End Class